Unit IA12R1_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure IA12R1(var F :Array of Real; var T :Array of Real;
                M :Integer; N :Integer);

implementation

procedure IA12R1(var F :Array of Real; var T :Array of Real;
                M :Integer; N :Integer);
var
K,L,K1,K2,L1,L2 :Integer;
FK,T1,T2,TM,R,F1,F2,D :Real;
const
SYS053 :Real = 3.4E17;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11;
begin
L := 1;
if ( M = 0 ) 
 then goto _9;
T1 := SYS053;
if ( M > 0 ) 
 then T1 := -T1;
if ( N <= 1 ) 
 then goto _9;
_1:
L1 := L;
T2 := F[L-1];
R := T2-T1;
if ( M < 0 ) 
 then R := -R;
if ( R < 0.0 ) 
 then goto _5;
FK := T1;
T1 := T2;
T2 := FK;
D := 0.0;
K1 := L;
K2 := L;
F1 := T1;
F2 := T1;
TM := T1;
L2 := L+1;
for K:=L2 to N do
 begin
  FK := F[K-1];
  R := Abs(TM-FK);
  if ( R <= D ) 
   then goto _4;
  if ( FK > TM ) 
   then goto _2;
  K1 := K;
  F1 := FK;
  goto _3;
_2:
  K2 := K;
  F2 := FK;
_3:
  TM := 0.5*(F1+F2);
  D := 0.5*(F2-F1);
  R := TM-T1;
  if ( M < 0 ) 
   then R := -R;
  if ( R > 0.0 ) 
   then goto _4;
  T1 := TM;
  L1 := K;
_4:
 end;
R := T1-T2;
if ( M < 0 ) 
 then R := -R;
if ( R < 0.0 ) 
 then T1 := T2;
_5:
for K:=L to L1 do
 begin
_6:
  T[K-1] := T1;
 end;
L := L1+1;
if ( L-N ) < 0
 then goto _1
 else if ( L-N ) > 0
       then goto _11
       else goto _7;
_7:
if ( M < 0 ) 
 then goto _8;
T[N-1] := EMax1(T1,F[N-1]);
goto _11;
_8:
T[N-1] := EMin1(T1,F[N-1]);
goto _11;
_9:
for K:=1 to N do
 begin
_10:
  T[K-1] := F[K-1];
 end;
_11:
end;

end.
